`line 1 "D:\Documents and Settings\tak sugawara\My Documents\Visual Studio 2005\Projects\cpu_project_archive\veritak_quartas_project\test.v"
`timescale 1ns/1ps





module test;
	
	reg clock=0;
	reg reset=0;
	reg [15:0] port_in_data=0;
	reg sync=0;
	integer counter=0;

	wire [15:0] port_out_data;

	always #( 30/2) clock=~clock;
	
	initial begin
		reset=1;
		#105;
		reset=0;
		#1000000;
		$finish;
	end

	task inc_port_in_data;
		begin
			counter=counter+1;
			if (counter[0])		port_in_data=port_in_data+1;
		end
	endtask

	cpu cpu(.clock,.reset,.sync,.port_in_data,.port_out_data);

	always @(negedge clock) begin
		inc_port_in_data;
		if (port_out_data==51) begin
			repeat( 100) begin
				@(negedge clock);
			end	
			sync=1;
			@(negedge clock);
			sync=0;
		end
	end
      localparam integer MB_YESNO=4;
	localparam integer MB_YES=6;
	localparam integer MB_NO=7;
	localparam integer TOP_MOST=32'h4_0000;

	integer handle,i;
	reg [8*20:1] str;
	reg [31:0] data;
	integer result;
	parameter integer WM_COMMAND=32'h111;
	initial begin
	
		handle=$FindWindow("MyCPU");
		if (handle) begin
			
		end else begin :loop0
				result=$MessageBox("悤BVisual fobKN܂H","VeritakMessageBox",MB_YESNO | TOP_MOST );
				if (result==MB_YES)  begin
					$shell_execute("cpu");
					repeat(100) begin
						$Sleep(100);
						handle=$FindWindow("MyCPU");
						if (handle) disable loop0;
					end
				end
		end
		if (handle) begin	
			$SendMessage(handle,WM_COMMAND,256,0);
			for (i=0;i<32;i=i+1) begin
				data=cpu.rom.romdata(i);
				$SendMessage(handle,WM_COMMAND,i+256,data);
			end
			$MessageBox("GUȈł܂BKvȂMyCPUROMXgŁAu[N|Cgݒ肵ĂB̌OK{^ĂB","VeritakMessageBox");
		end	else begin
			

		end
	end
	always @(negedge clock) begin
	
		handle_7led=$FindWindow("7LED");
		if (handle_7led) begin :LED
			reg [31:0] led_value={1'b0,decoder(port_out_data[15:12]),
						  1'b0,decoder(port_out_data[11:8]),
						  1'b0,decoder(port_out_data[7:4]),
						  1'b0,decoder(port_out_data[3:0])};
			     $SendMessage(handle_7led,WM_COMMAND,led_value,0);
		end
		handle=$FindWindow("MyCPU");
		if (handle) begin
			
			     $SendMessage(handle,WM_COMMAND,1,cpu.rfile.out_dataA);
  			     $SendMessage(handle,WM_COMMAND,2,cpu.rfile.out_dataB);
			     $SendMessage(handle,WM_COMMAND,3,cpu.rfile.alu_data);
			     $SendMessage(handle,WM_COMMAND,4,cpu.rfile.r0);
 			     $SendMessage(handle,WM_COMMAND,5,cpu.rfile.r1);
 			     $SendMessage(handle,WM_COMMAND,6,cpu.rfile.port_reg);



   			    $SendMessage(handle,WM_COMMAND,7,cpu.ALU.portA);
			    $SendMessage(handle,WM_COMMAND,8,cpu.ALU.portB);
 			    $SendMessage(handle,WM_COMMAND,9,cpu.ALU.alu_out);
 			     $SendMessage(handle,WM_COMMAND,10,cpu.ALU.command);
 			     $SendMessage(handle,WM_COMMAND,11,cpu.ALU.jump_cond);
			     $SendMessage(handle,WM_COMMAND,12,cpu.loop_counter);
				
				result=$SendMessage(handle,WM_COMMAND,0,cpu.pc);
				if (result==-1) begin
					$stop;
				end
			
		end


	end

	integer handle_7led;
	initial begin 
	
				
		handle_7led=$FindWindow("7LED");
	
			if (!handle_7led)begin :loop1
				result=$MessageBox("|[go͂7ZOgLEDplɏo͂܂H","VeritakMessageBox",MB_YESNO | TOP_MOST );
				if (result==MB_YES) begin
					$shell_execute("LED7SEG");
					repeat(100) begin
						$Sleep(100);
				 		handle_7led=$FindWindow("7LED");
						if (handle_7led) disable loop1;
					end	 
				end
			end
	end
	

	function [6:0] decoder(input  [3:0] din);
      	case (din)
       	4'b0000 : decoder = 7'b1111110;
        	4'b0001 : decoder = 7'b0110000;
        	4'b0010 : decoder = 7'b1101101;
       	4'b0011 : decoder = 7'b1111001;
       	4'b0100 : decoder = 7'b0110011;
        	4'b0101 : decoder = 7'b1011011;
        	4'b0110 : decoder = 7'b1011111;
        	4'b0111 : decoder = 7'b1110000;
        	4'b1000 : decoder = 7'b1111111;
       	4'b1001 : decoder = 7'b1111011;
       	4'b1010 : decoder = 7'b1110111;
       	4'b1011 : decoder = 7'b0011111;
        	4'b1100 : decoder = 7'b1001110;
        	4'b1101 : decoder = 7'b0111101;
        	4'b1110 : decoder = 7'b1001111;
        	4'b1111 : decoder = 7'b1000111;
           endcase
	endfunction

endmodule

`line 1 "D:\Documents and Settings\tak sugawara\My Documents\Visual Studio 2005\Projects\cpu_project_archive\veritak_quartas_project\register_file.v"
 
 
 
 
 
 
 









 
 














module cpu( input clock, reset,
		     input [15:0] port_in_data,
		     input sync,
		     output [15:0] port_out_data);

	localparam integer Loop_counter_width=10;
	localparam integer Stop_count=2**Loop_counter_width -1;

	reg [4:0] pc;
	reg [15:0] port_in_reg;
	reg [Loop_counter_width-1:0] loop_counter;
	reg sync_ff,sync_ff2;

	wire [31:0] rom_data;
	wire [3:0] command=rom_data[31:28];
	wire [1:0] A_address=rom_data [27:26];
	wire [1:0] B_address=rom_data[25:24];
	wire [1:0] write_address=rom_data[23:22];
	wire [2:0] jump_cond=rom_data[21:19];
	wire [2:0] reserved=rom_data[18:16];
	wire [15:0] immediate_data=rom_data[15:0];
	wire loop_flag=reserved[0];


		
	wire [15:0] out_dataA,out_dataB;
	wire [15:0] alu_data;
	

	wire write=1'b1;
	wire [15:0]  Aport_data=command== 4'b0001 	? immediate_data :port_in_reg;



     always @(posedge clock, posedge reset) begin
		if (reset) loop_counter<=Stop_count;
		else if (loop_flag && loop_counter==Stop_count) loop_counter<=immediate_data;
		else if (loop_flag) loop_counter<=loop_counter -1;
		else loop_counter<=Stop_count;
     end


      always @(posedge clock, posedge reset) begin
		if (reset) sync_ff<=0;
		else 	sync_ff<=sync;
     end
     always @(posedge clock, posedge reset) begin
		if (reset) sync_ff2<=0;
		else 	sync_ff2<=sync_ff;
     end

      wire sinc_pos_edge_detected=sync_ff & ~sync_ff2;


	always @(posedge clock, posedge reset) begin
		if (reset) pc<=0;
		else if (command== 4'b0101 && alu_data[0]==1'b1) pc<=immediate_data;
	      else if (command== 4'b0110) begin
			if (sinc_pos_edge_detected) pc<=pc+1;
		      else pc<=pc;
	      end else if (loop_flag ) begin
			if (loop_counter==0) pc<=pc+1;
			else pc<=pc;
		end else pc<=pc+1;
	end


      always @(posedge clock,posedge reset) begin
		if (reset) port_in_reg<=0;
		else port_in_reg<=port_in_data;

	end



	rom rom(.rom_address(pc),.Data(rom_data));		


	 alu  ALU( .command(command),
			    .jump_cond(jump_cond),
			   .portA(out_dataA),
			   .portB(out_dataB),
			   .alu_out(alu_data));



	register_file rfile(.clock(clock),
				.write(write),
				.reset(reset),
				.A_address(A_address),
				.B_address(B_address),
				.write_address(write_address),
				.alu_data(alu_data),
				.out_dataA(out_dataA),
				.out_dataB(out_dataB),
				.port_in_data(Aport_data),
				.port_out_data(port_out_data));
				
	

endmodule		


module alu (input [3:0] command,
		    input [2:0] jump_cond,
		    input [15:0] portA,portB,
		   output reg [15:0] alu_out);

	always @* begin
		case (command) 
			 4'b0000 :  alu_out=portA+portB;
			 4'b0010 :  alu_out=portA-portB;
			 4'b0011: alu_out=portB >>1;
			 4'b0100: alu_out=portB <<1;
	







			 4'b0101 :   
					case (jump_cond) 
						 3'b000 : alu_out=portA==portB;
						 3'b001:alu_out=portA !=portB;
						 3'b010 :  alu_out=1;
						 3'b011 :alu_out=0;
						 3'b100 :  if (portA < portB) alu_out=1;
							 else			 alu_out=0;
						 3'b101 : if (portA > portB) alu_out=1;
							 else 			alu_out=0;
						default: alu_out=0;
					endcase
			default:  alu_out=portA+portB;


		endcase
     end


endmodule

module rom ( input [4:0] rom_address,
			output [31:0] Data);




parameter [1:0]  Port= 2'b11,
			     R0=  2'b01,
			     R1=  2'b10,
			     ZR=  2'b00;

parameter [15:0] Zero_Im=16'h0000;

parameter [3:0]  Load_Im= 4'b0001,
			    Add= 4'b0000,
			    Sub= 4'b0010,
			    Shift_L= 4'b0011,
			    Shift_R= 4'b0100,
			    Jmp= 4'b0101,
			    Sync= 4'b0110
	 
				;
	






parameter [2:0] Eq= 3'b000,
			    Not_Eq= 3'b001,
			    Always= 3'b010,
			    Always_Not= 3'b011,
			   LT= 3'b100,
			   GT= 3'b101,
			   LTE= 3'b110,
			   GTE= 3'b111;	
			    
parameter [2:0] Reserved=3'b000,
			   Loop_Enabled=3'b001;










































 














 function [31:0]romdata;
        input [4:0] address;
                case (address)			
                        0:  romdata = { Load_Im , Port , ZR ,  R0 , Eq , Reserved , 16 'd  1 };
			     1:  romdata = { Add , ZR , ZR ,  Port , Eq , Reserved , Zero_Im };		
                        2:  romdata = { Add ,  R0 ,  Port ,  Port , Eq , Loop_Enabled , 16 'd  100 };
		  	     3:  romdata = { Add , ZR , ZR ,  Port , Eq , Reserved , Zero_Im };
			     4:  romdata = { Load_Im , Port , ZR ,  R0 , Eq , Reserved , 16 'd  2 };		
                        5 : romdata = { Add ,  R0 ,  Port ,  Port , Eq , Loop_Enabled , 16 'd  50 };
			     6:  romdata = { Add , ZR , ZR ,  Port , Eq , Reserved , Zero_Im };	
 			     7:  romdata = { Load_Im , Port , ZR ,  R0 , Eq , Reserved , 16 'd  4 };		
                        8 : romdata = { Add ,  R0 ,  Port ,  Port , Eq , Loop_Enabled , 16 'd  25 };
			     9 : romdata = { Load_Im , Port , ZR ,  Port , Eq , Reserved , 16 'd  75 };
			    10: romdata = { Add ,  ZR ,  Port ,  Port , Eq , Loop_Enabled , 16 'd  25 };
  			    11:  romdata = { Load_Im , Port , ZR ,  Port , Eq , Reserved , 16 'd  51 };
			    12: romdata = { Sync , ZR , ZR , ZR , Eq , Reserved , Zero_Im };	
			    13: romdata = { Load_Im , Port , ZR ,  R1 , Eq , Reserved , 16 'd  44000 };
			     14: romdata = { Jmp ,  R1 ,  Port , ZR , LT , Reserved , 16 'd  1 };
                        15 : romdata = { Shift_R , ZR ,  Port ,  Port , Eq , Reserved , Zero_Im };
			     16: romdata = { Jmp , ZR , ZR , ZR , Always , Reserved , 16 'd  14 };
                    
                   
                   
                   
                   
                   
                  
                  
                   
                        17 : romdata =0;
                        18 : romdata =0;
                        19 : romdata =0;
                        20 : romdata =0;
			     default    : romdata=0;
                endcase
 endfunction
 
 assign Data = romdata(rom_address);


endmodule


module register_file(input clock,write,reset,
					 input [1:0] A_address,
					 input [1:0] B_address,
					 input [1:0] write_address,
					 input [15:0] alu_data,port_in_data,
					 output [15:0] out_dataA, out_dataB,port_out_data);

   
	reg [15:0] port_reg,r0,r1;
	
	
	always @(posedge clock,posedge reset) begin
		if (reset) begin
				port_reg<=0;
				r0<=0;
				r1<=0;
			end else if (write) begin
				case (write_address)
					 2'b11: port_reg<=alu_data;
					 2'b01: r0<=alu_data;
					 2'b10: r1<=alu_data;
				
				endcase
		end
	end

	assign out_dataA=A_address== 2'b11 ? port_in_data :
					 A_address== 2'b01 ? r0 :
					 A_address== 2'b10 ?  r1 : 0;

					
   	assign out_dataB=B_address== 2'b11 ? port_reg :
					 B_address== 2'b01 ? r0 :
					 B_address== 2'b10 ? r1 : 0;


	assign port_out_data=port_reg;

endmodule


